% PiecewiseEvaluable (subclass of Evaluable) Evaluate piecewise (e.g., jumping diffusion) evaluable on edges.

classdef PiecewiseEvaluable < Evaluable
    %% properties
    properties (GetAccess=public, SetAccess=protected)
        mesh
        functionHandle
        normalVector
    end
    
    %% methods
    methods (Access=public)
        function obj = PiecewiseEvaluable(mesh, functionHandle, normalVector)
            arguments
                mesh (1,1) Mesh
                functionHandle (1,1) function_handle
                normalVector (2,:) double
            end
            
            obj.mesh = mesh;
            obj.functionHandle = functionHandle;
            obj.normalVector = normalVector;
        end
        
        function val = eval(obj, bary, idx)
            arguments
                obj
                bary Barycentric2D
                idx {mustBeIndexVector} = ':'
            end
            
            val = obj.functionHandle(elementwiseCoordinates(obj.mesh, bary, idx), obj.normalVector);
        end
        
        function val = evalEdge(obj, bary, idx)
            arguments
                obj
                bary Barycentric1D
                idx {mustBeIndexVector} = ':'
            end
            
            val = obj.functionHandle(edgewiseCoordinates(obj.mesh, bary, idx), obj.normalVector);
        end
    end
end